<?php

if (!defined('FORUM_ROOT') )
	define('FORUM_ROOT', '../../');

require FORUM_ROOT.'include/common.php';
require $forum_url['pan_private_chat_path'].'/inc/functions.php';
require $forum_url['pan_private_chat_path'].'/inc/chat_parser.php';

if ($forum_user['is_guest'])
	message($lang_common['Bad request']);

$action = isset($_POST['action']) ? $_POST['action'] : null;
$errors = $forum_page = $return_data = array();

if (file_exists(FORUM_ROOT.'extensions/pan_private_chat/lang/'.$forum_user['language'].'/pan_private_chat.php') )
	require FORUM_ROOT.'extensions/pan_private_chat/lang/'.$forum_user['language'].'/pan_private_chat.php';
else
	require FORUM_ROOT.'extensions/pan_private_chat/lang/English/pan_private_chat.php';

$online_info = array();
$query = array(
	'SELECT'	=> 'o.user_id, o.logged, o.idle',
	'FROM'		=> 'online AS o',
	'WHERE'		=> 'o.user_id > 1'
);
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
while ($fetch_online = $forum_db->fetch_assoc($result))
	$online_info[$fetch_online['user_id']] = $fetch_online;//['user_id']


if ($action == 'list_msg')
{
	$receiver_id = isset($_POST['receiver_id']) ? intval($_POST['receiver_id']) : 0;
	$chars = isset($_POST['chars']) ? intval($_POST['chars']) : 0;

	if ($receiver_id > 1)
	{
		if (file_exists($forum_url['pan_private_chat_path'].'/cache/typing.php') )
			require $forum_url['pan_private_chat_path'].'/cache/typing.php';
		
		pan_chat_gen_cache_chars($receiver_id, $chars);
		
		$query = array(
			'SELECT'	=> 'u.username',
			'FROM'		=> 'users AS u',
			'WHERE'		=> 'u.id='.$receiver_id,
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$user_info = $forum_db->fetch_assoc($result);
		$receiver = $user_info['username'];
		
		$receiver_ava = get_avatar_once($receiver_id);
		$forum_user_ava = get_avatar_once($forum_user['id']);
		
		$query = array(
			'SELECT'	=> 'ch.id, ch.sender, ch.sender_id, ch.receiver, ch.receiver_id, ch.message, ch.posted, ch.status',
			'FROM'		=> 'pan_private_chat AS ch',
			'WHERE'		=> '(ch.receiver_id='.$receiver_id.' AND ch.sender_id='.$forum_user['id'].') OR (ch.receiver_id='.$forum_user['id'].' AND ch.sender_id='.$receiver_id.')', 
			'ORDER BY'	=> 'ch.posted ASC'
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

		if ($forum_db->num_rows($result) < 1)
			echo '<li><span class="dialog-empty">'.$lang_pan_private_chat['no_msg'].' <strong>'.$receiver.'</strong></span></li>';

		$sound_new_msg = false;
		while ($chat_info = $forum_db->fetch_assoc($result) )
		{
			$chat_message = parse_message($chat_info['message'], 0);
			
			if ($chat_info['sender_id'] == $forum_user['id'])
			{
				
				$sender_status = $chat_info['status'] == 'read' ? '<span class="sender-status-read">'.$lang_pan_private_chat['status_read'].'</span>' : '<span class="sender-status-sent">'.$lang_pan_private_chat['status_sent'].'</span>';
				
				echo '<li>
						<div class="sender">
							'.$forum_user_ava.'
							<div class="sender-info">
								<span class="sender-name">'. $forum_user['username'].': </span>
								<div class="sender-msg">'.$chat_message.'</div>
								'.$sender_status.'
								<span class="sender-time">'.format_time($chat_info['posted']).'</span>
							</div>
						</div>
					</li>';
			}
			else if ($chat_info['sender_id'] == $receiver_id)
			{
				echo '<li>
						<div class="receiver">
							'.$receiver_ava.'
							<div class="receiver-info">
								<span class="receiver-name">'. $receiver.': </span>
								<div class="receiver-msg">'.$chat_message.'</div>
								<span class="receiver-time">'.format_time($chat_info['posted']).'</span>
							</div>
						</div>
					</li>';
					
			if ($chat_info['status'] == 'sent')
				$sound_new_msg = true;
			}
		
		}
		
		$sender_write_msg = (isset($pan_chat_temp[$receiver_id]['receiver']) && ($pan_chat_temp[$receiver_id]['receiver'] == $forum_user['id']) ) ? '<strong>'.$receiver.'</strong>'.$lang_pan_private_chat['sender_write_msg'].'<img src="'.$forum_url['pan_private_chat_url'].'/img/process/loading.gif" />' : '<span style="opacity:0;">.<span>';
		echo '<div class="sender-write-msg">'.$sender_write_msg.'</div>';
		
		if ($sound_new_msg === true)
		{
			echo '<audio autoplay>
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.wav" type="audio/wav">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.ogg" type="audio/ogg">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.mp3" type="audio/mpeg">
			</audio>';
		}
		
		
		//Update Status
		$query = array(
			'UPDATE'	=> 'pan_private_chat',
			'SET'		=> 'status=\'read\'',
//			'WHERE'		=> 'sender_id='.$receiver_id
			'WHERE'		=> 'sender_id='.$receiver_id.' AND receiver_id='.$forum_user['id']
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
	}
}
else if ($action == 'list_contacts')
{
	$unread_messages = pan_private_chat_get_unread_msg();
	$o_active_contacts = $forum_config['o_pan_private_chat_active_contacts'] > 0 ? ' AND last_visit>'.(time()-($forum_config['o_pan_private_chat_active_contacts']*86400)).'' : '';
	
	$chat_info2 = array();
	$query = array(
		'SELECT'	=> 'g.g_id, g.g_title, g.g_user_title, g.g_id AS group_id, u.id, u.username, u.num_posts, u.registered, u.avatar',
		'FROM'		=> 'groups AS g',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'users AS u',
				'ON'			=> 'g.g_id=u.group_id'
			)
		),
		'WHERE'		=> 'g.g_id!='.FORUM_GUEST.' AND u.id!='.$forum_user['id'].' AND u.group_id!=0'.$o_active_contacts,
		'ORDER BY'	=> 'u.username ASC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	while ($chat_info = $forum_db->fetch_assoc($result))
		$chat_info2[$chat_info['id']] = $chat_info;
	
	$chat_info2 = pan_chat_sort_online($chat_info2, $online_info);

?>

		<div id="list_contacts" class="content-head">
			<span><?php printf($lang_pan_private_chat['contact_list'], $forum_config['o_pan_private_chat_active_contacts']); ?></span>
		</div>

		<div class="ct-group">

			<fieldset class="mf-set set1">
				<legend><span></span></legend>
				<div class="mf-box">
					<div id="dialog_window" class="dialog-window">
						<fieldset>

							<div class="user-list">
								<ul>
<?php
	foreach ($chat_info2 as $key => $list_users)
	{
		if (isset($unread_messages[$forum_user['id']][$list_users['id']]) )
			$unread_msg = '<span class="unread-msg">'.$unread_messages[$forum_user['id']][$list_users['id']].'</span>';
		else
			$unread_msg = '';

		if (isset($online_info[$list_users['id']]) )
		{
			if ($online_info[$list_users['id']]['idle'] == '0')
				$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/online.gif" />';
			else if ($online_info[$list_users['id']]['idle'] == '1')
				$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/departed.png" />';
		} else {
			$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/offline.png" />';
		}
		
		echo '<li>
				<a href="javascript://" onClick="dialogContact('.$list_users['id'].');">'.get_avatar($list_users).'</a>
				<span class="user-info">
					<a href="javascript://" onClick="dialogContact('.$list_users['id'].');">'.$list_users['username'].'</a>
					'.$status.'
					<span class="user-title">'.$list_users['g_title'].'</span>
					'.$unread_msg.'
				</span>
			</li>';
	}
?>
								</ul>
							</div>

						</fieldset>
					</div>
				</div>
			</fieldset>
		
		</div>
	
<?php
}
else if ($action == 'dialog_contact')
{
	$receiver_id = isset($_POST['receiver_id']) ? intval($_POST['receiver_id']) : 0;
	$clear = isset($_POST['clear']) ? intval($_POST['clear']) : 0;

	$max_lenght_msg = ($forum_config['o_pan_private_chat_max_lenght_msg'] > 0) ? $forum_config['o_pan_private_chat_max_lenght_msg'] : '10000';
	
	if ($receiver_id > 1)
	{
		if ($clear == '1')
		{
			$query = array(
				'DELETE'	=> 'pan_private_chat',
				'WHERE'		=> '(receiver_id='.$receiver_id.' AND sender_id='.$forum_user['id'].') OR (receiver_id='.$forum_user['id'].' AND sender_id='.$receiver_id.')'
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
		}
		
		$query = array(
			'SELECT'	=> 'u.username',
			'FROM'		=> 'users AS u',
			'WHERE'		=> 'u.id='.$receiver_id,
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$user_info = $forum_db->fetch_assoc($result);
		$receiver = $user_info['username'];
		
		$receiver_ava = get_avatar_once($receiver_id);
		$forum_user_ava = get_avatar_once($forum_user['id']);
		
		$query = array(
			'SELECT'	=> 'ch.id, ch.sender, ch.sender_id, ch.receiver, ch.receiver_id, ch.message, ch.posted, ch.status',
			'FROM'		=> 'pan_private_chat AS ch',
			'WHERE'		=> '(ch.receiver_id='.$receiver_id.' AND ch.sender_id='.$forum_user['id'].') OR (ch.receiver_id='.$forum_user['id'].' AND ch.sender_id='.$receiver_id.')', 
			'ORDER BY'	=> 'ch.posted ASC'
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
?>

		<div class="content-head">
			<span><?php printf($lang_pan_private_chat['dialog_users'], '<strong><a href="'.forum_link($forum_url['user'], $receiver_id).'" target="_blank" title="'.$lang_pan_private_chat['open_new_window'].'">'.$receiver.'</a></strong>'); ?></span>
		</div>

		<div class="ct-group">
			
			<form id="form_sent" class="frm-form" method="post" accept-charset="utf-8" action="javascript:void(null);" enctype="multipart/form-data">

				<div class="hidden">
					<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_private_chat_body'])) ?>" />
					<input type="hidden" name="action" value="add_msg" />
					<input type="hidden" name="receiver_id" value="<?php echo $receiver_id ?>" />
					<input type="hidden" name="receiver" value="<?php echo $receiver ?>" />
				</div>
				
				<fieldset class="mf-set set1">
					<legend><span></span></legend>
					<div class="mf-box">
						<div id="dialog_window" class="dialog-window wallpaper">
							<fieldset>

								<div class="dialog-chat">
									<ul>

										<div id="chat_list_msg"></div>

									</ul>
								</div>
	
							</fieldset>
						</div>
					</div>
				</fieldset>
				
				<div id="chat_smilies" style="display:none">
					<?php pan_chat_smiles($forum_url['pan_private_chat_url'].'/img/smiles/'); ?>
				</div>
				
				
				
				<div id="chat-bbcode-head">
					<div id="chat-bbcode-buttons">

						<img src="<?php echo $base_url ?>/extensions/pan_private_chat/img/smiles/ab.gif" id="chat_bbcode_button_smiles" class="image chat-btn-img" onclick="chatShowHide('chat_smilies');" title="<?php echo $lang_pan_private_chat['button_title_smiles'] ?>">
								
						<div class="fileform chat-btn-img">
							<img src="<?php echo $base_url ?>/extensions/pan_private_chat/img/add_image.png" title="<?php echo $lang_pan_private_chat['button_title_img'] ?>" id="chat_bbcode_button_image" class="image">
							<input id="chat_uploade_img" type="file" name="userfile" onchange="uploadeFile()" />
						</div>
						
						<input type="button" title="<?php echo $lang_pan_private_chat['button_title_b'] ?>" class="bb-btn chat-btn-img" data-tag="b" id="chat_bbcode_button_b" value="B" name="b" onclick="insertTagToChat('[b]','[/b]')" />
						
						<input type="button" title="<?php echo $lang_pan_private_chat['button_title_code'] ?>" class="bb-btn chat-btn-img" data-tag="code" id="chat_bbcode_button_code" value="{}" name="code" onclick="insertTagToChat('[code]','[/code]')" />
						
					</div>
				</div>
				
				
				<div class="chat-textarea">
					
					<div class="chat-txt-input"><span class="chat-fld-input"><textarea id="textarea_msg" name="message" rows="4" cols="auto" maxlength="<?php echo $max_lenght_msg ?>" onkeypress="countLenMsg(this, <?php echo $max_lenght_msg ?>);" onkeyup="countLenMsg(this, <?php echo $max_lenght_msg ?>);" onchange="countLenMsg(this, <?php echo $max_lenght_msg ?>);" autofocus></textarea></span></div>

					<div class="txt-box-info"><?php echo $lang_pan_private_chat['count_lenght'] ?><span id="count_lenght_msg"><?php echo $max_lenght_msg ?></span><?php echo $lang_pan_private_chat['from'] ?><span id="count_lenght_msg_max"><?php echo $max_lenght_msg ?></span></div>
						
				</div>
				
				<div class="frm-buttons">
					<span class="submit primary"><input type="submit" value="<?php echo $lang_pan_private_chat['button_send'] ?>" OnClick="sendMessage();"></span>
					<span class="submit primary caution"><input type="submit" value="<?php echo $lang_pan_private_chat['button_clear'] ?>" OnClick="clearDialog();"></span>
				</div>
			
			</form>
			
		</div>
<?php
		
		if ($clear == '1')
		{
			echo '<audio autoplay>
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/clear.wav" type="audio/wav">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/clear.ogg" type="audio/ogg">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/clear.mp3" type="audio/mpeg">
			</audio>';
		}

		//Update Status
		$query = array(
			'UPDATE'	=> 'pan_private_chat',
			'SET'		=> 'status=\'read\'',
//			'WHERE'		=> 'sender_id='.$receiver_id
			'WHERE'		=> 'sender_id='.$receiver_id.' AND receiver_id='.$forum_user['id']
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	}

}
else if ($action == 'add_msg')
{
	// Load the post.php language file
	require FORUM_ROOT.'lang/'.$forum_user['language'].'/post.php';

	$receiver_id = isset($_POST['receiver_id']) ? intval($_POST['receiver_id']) : 0;
	$receiver = isset($_POST['receiver']) ? $_POST['receiver'] : null;
	$message = isset($_POST['message']) ? forum_linebreaks(forum_trim($_POST['message'])) : '';

	$max_lenght_msg = ($forum_config['o_pan_private_chat_max_lenght_msg'] > 0) ? $forum_config['o_pan_private_chat_max_lenght_msg'] : '10000';

	if (iconv_strlen($message, 'UTF-8') > $forum_config['o_pan_private_chat_max_lenght_msg'])
		$errors[] = sprintf($lang_post['Too long message'], forum_number_format( iconv_strlen($message, 'UTF-8') ), forum_number_format($forum_config['o_pan_private_chat_max_lenght_msg']));

	if (isset($_FILES['file']['tmp_name']) )
	{
		$ext_types = array('.jpg', '.jpeg', '.png', '.gif');
		$file_tmp_name = $_FILES['file']['tmp_name'];
		$file_name = $_FILES['file']['name'];
		$file_size = $_FILES['file']['size'];
		$file_ext = strtolower(strrchr($file_name,'.') );
		$file_name = sha1($file_tmp_name.time() );
		
		$path_to_file = $forum_url['pan_private_chat_path'] .'/cache/images/'. $file_name.$file_ext;
		$url_to_file = $forum_url['pan_private_chat_url'] .'/cache/images/'. $file_name.$file_ext;
		
		if (in_array($file_ext, $ext_types) && $file_size < 500000)
		{
			if (move_uploaded_file($file_tmp_name, $path_to_file) )
			{
				$message = '[img]'.$url_to_file.'[/img]';
			}
		} else {
			$errors[] = $lang_pan_private_chat['error_img_size'];
		}
	}

	$message = preparse_bbcode($message, $errors);

	if ($message == '')
		$errors[] = $lang_post['No message'];

	if (empty($errors) && $receiver_id > 0 && $message != '')
	{
		$query = array(
			'INSERT'	=> 'sender, sender_id, receiver, receiver_id, message, posted, status',
			'INTO'		=> 'pan_private_chat',
			'VALUES'	=> '\''.$forum_db->escape($forum_user['username']).'\', \''.$forum_db->escape($forum_user['id']).'\', \''.$forum_db->escape($receiver).'\', \''.$forum_db->escape($receiver_id).'\', \''.$forum_db->escape($message).'\', '.time().', \'sent\''
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		$new_id_msg = $forum_db->insert_id();
		
		//Send message to Email once
		$query = array(
			'SELECT'	=> 'COUNT(id)',
			'FROM'		=> 'pan_private_chat',
			'WHERE'		=> 'receiver_id='.$receiver_id.' AND sender_id='.$forum_user['id'].' AND status=\'sent\'',
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$num_new_msg = $forum_db->result($result);

		//Send message to email
		if ($num_new_msg < 2)
			pan_private_chat_email_new_msg($receiver_id);
		
	} else {
//		$errors['error'] = 'error';
//		json_encode($_POST);
	}

	if ($receiver_id > 0 && !empty($receiver))
	{
		$receiver_ava = get_avatar_once($receiver_id);
		$forum_user_ava = get_avatar_once($forum_user['id']);
		
		$query = array(
			'SELECT'	=> 'ch.id, ch.sender, ch.sender_id, ch.receiver, ch.receiver_id, ch.message, ch.posted, ch.status',
			'FROM'		=> 'pan_private_chat AS ch',
			'WHERE'		=> '(ch.receiver_id='.$receiver_id.' AND ch.sender_id='.$forum_user['id'].') OR (ch.receiver_id='.$forum_user['id'].' AND ch.sender_id='.$receiver_id.')',
			'ORDER BY'	=> 'ch.posted ASC'
		);
		
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

?>
		<div class="content-head">
			<span><?php printf($lang_pan_private_chat['dialog_users'], '<strong><a href="'.forum_link($forum_url['user'], $receiver_id).'" target="_blank" title="'.$lang_pan_private_chat['open_new_window'].'">'.$receiver.'</a></strong>'); ?></span>
		</div>

		<div class="ct-group">
			
			<form id="form_sent" class="frm-form" method="post" accept-charset="utf-8" action="javascript:void(null);" enctype="multipart/form-data">

				<div class="hidden">
					<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_private_chat_body'])) ?>" />
					<input type="hidden" name="receiver_id" value="<?php echo $receiver_id ?>" />
					<input type="hidden" name="receiver" value="<?php echo $receiver ?>" />
				</div>
				
				<fieldset class="mf-set set1">
					<legend><span></span></legend>
					<div class="mf-box">
						<div id="dialog_window" class="dialog-window wallpaper">
							<fieldset>

								<div class="dialog-chat">
									<ul>
<?php
		
		$count_max_msg = 0;
		while ($chat_info = $forum_db->fetch_assoc($result) )
		{
			$count_max_msg++;
			if (!isset($chat_min_id) && $chat_info['id'])
				$chat_min_id = $chat_info['id'];
			else if ($chat_info['id'] < $chat_min_id)
				$chat_min_id = $chat_info['id'];
		}
?>
										<div id="chat_list_msg"></div>

									</ul>
								</div>

							</fieldset>
						</div>
					</div>
				</fieldset>
				
				<div id="chat_smilies" style="display:none">
					<?php pan_chat_smiles($forum_url['pan_private_chat_url'].'/img/smiles/'); ?>
				</div>
				
				<div id="chat-bbcode-head">
					<div id="chat-bbcode-buttons">

						<img src="<?php echo $base_url ?>/extensions/pan_private_chat/img/smiles/ab.gif" id="chat_bbcode_button_smiles" class="image chat-btn-img" onclick="chatShowHide('chat_smilies');" title="<?php echo $lang_pan_private_chat['button_title_smiles'] ?>">
								
						<div class="fileform chat-btn-img">
							<img src="<?php echo $base_url ?>/extensions/pan_private_chat/img/add_image.png" title="<?php echo $lang_pan_private_chat['button_title_img'] ?>" id="chat_bbcode_button_image" class="image">
							<input id="chat_uploade_img" type="file" name="userfile" onchange="uploadeFile()" />
						</div>
						
						<input type="button" title="<?php echo $lang_pan_private_chat['button_title_b'] ?>" class="bb-btn chat-btn-img" data-tag="b" id="chat_bbcode_button_b" value="B" name="b" onclick="insertTagToChat('[b]','[/b]')" />
						
						<input type="button" title="<?php echo $lang_pan_private_chat['button_title_code'] ?>" class="bb-btn chat-btn-img" data-tag="code" id="chat_bbcode_button_code" value="{}" name="code" onclick="insertTagToChat('[code]','[/code]')" />
						
					</div>
				</div>
				
				<div class="chat-textarea">
					
					<div class="chat-txt-input"><span class="chat-fld-input"><textarea id="textarea_msg" name="message" rows="4" cols="auto" maxlength="<?php echo $max_lenght_msg ?>" onkeypress="countLenMsg(this, <?php echo $max_lenght_msg ?>);" onkeyup="countLenMsg(this, <?php echo $max_lenght_msg ?>);" onchange="countLenMsg(this, <?php echo $max_lenght_msg ?>);" ></textarea></span></div>

					<div class="txt-box-info"><?php echo $lang_pan_private_chat['count_lenght'] ?><span id="count_lenght_msg"><?php echo $max_lenght_msg ?></span><?php echo $lang_pan_private_chat['from'] ?><span id="count_lenght_msg_max"><?php echo $max_lenght_msg ?></span></div>
						
				</div>

				<div class="frm-buttons">
					<span class="submit primary"><input type="submit" value="<?php echo $lang_pan_private_chat['button_send'] ?>" OnClick="sendMessage();"></span>
					<span class="submit primary caution"><input type="submit" value="<?php echo $lang_pan_private_chat['button_clear'] ?>" OnClick="clearDialog();"></span>
				</div>
			
			</form>
			
			<div id="chat_popup"></div>
		
		</div>
<?php

		if (isset($chat_min_id) && ($count_max_msg > $forum_config['o_pan_private_chat_max_num_msg']) )
		{
			$query = array(
				'DELETE'	=> 'pan_private_chat',
				'WHERE'		=> 'id='.$chat_min_id,
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
		}
		
		if (isset($new_id_msg) )
		{
			echo '<audio autoplay>
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/message.wav" type="audio/wav">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/message.ogg" type="audio/ogg">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/message.mp3" type="audio/mpeg">
			</audio>';
		}
		
	}

	pan_chat_get_uploaded_imgs($forum_url['pan_private_chat_path'] .'/cache/images', $all_files);
	
	if (!empty($all_files) )
		pan_chat_clear_images($all_files);

}
else if ($action == 'list_chats')
{
	$unread_messages = pan_private_chat_get_unread_msg();
	
	if (file_exists($forum_url['pan_private_chat_path'].'/cache/update_online.php') )
		require $forum_url['pan_private_chat_path'].'/cache/update_online.php';
	else
		pan_chat_gen_cache_update_online($online_info);
	
	if (file_exists($forum_url['pan_private_chat_path'].'/cache/new_msg.php') )
		require $forum_url['pan_private_chat_path'].'/cache/new_msg.php';
	else
		pan_chat_gen_cache_new_msg($unread_messages);
	
	$list_chats = array();
	$query = array(
		'SELECT'	=> 'ch.id AS chid, ch.sender, ch.sender_id, ch.receiver, ch.receiver_id, ch.message, ch.posted, ch.status, u.id, u.username, u.avatar',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'users AS u',
				'ON'			=> '(u.id=ch.sender_id) OR (u.id=ch.receiver_id)'
			)
		),
		'FROM'		=> 'pan_private_chat AS ch',
		'WHERE'		=> 'ch.sender_id='.$forum_user['id'].' OR ch.receiver_id='.$forum_user['id'],
		'ORDER BY'	=> 'ch.posted DESC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	while ($chat_info = $forum_db->fetch_assoc($result))
	{
		if ($chat_info['id'] != $forum_user['id'])
		{
			if (!isset($list_chats[$chat_info['id']]) )
				$list_chats[$chat_info['id']] = $chat_info;
			else if ($chat_info['posted'] > $list_chats[$chat_info['id']]['posted'])
				$list_chats[$chat_info['id']] = $chat_info;
		}
	}
	
	$list_chats = pan_chat_sort_online($list_chats, $online_info);

?>

		<div id="list_open_chats" class="content-head">
			<span><?php echo $lang_pan_private_chat['list_open_chat'] ?></span>
		</div>

		<div class="ct-group">

			<fieldset class="mf-set set1">
				<legend><span></span></legend>
				<div class="mf-box">
					
					<div id="dialog_window" class="dialog-window">
						
						<fieldset>

							<div class="user-list">
								<ul>
<?php

	if ($forum_db->num_rows($result) < 1)
		echo '<span class="dialog-empty">'.$lang_pan_private_chat['not_dialogs'].'</span>';

	foreach ($list_chats as $chid => $chat_info)
	{
		if (isset($unread_messages[$forum_user['id']][$chat_info['sender_id']]) )
			$unread_msg = '<span class="unread-msg">'.$unread_messages[$forum_user['id']][$chat_info['sender_id']].'</span>';
		else
			$unread_msg = '';
		
		if (isset($online_info[$chid]) )
		{
			if ($online_info[$chid]['idle'] == '0')
				$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/online.gif" />';
			else if ($online_info[$chid]['idle'] == '1')
				$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/departed.png" />';
		} else {
			$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/offline.png" />';
		}
		
		echo '<li>
				<a href="javascript://" onClick="dialogContact('.$chat_info['id'].');">'.get_avatar($chat_info).'</a>
				<span class="user-info">
					<a href="javascript://" onClick="dialogContact('.$chat_info['id'].');">'.$chat_info['username'].'</a>
					'.$status.'
					<span id="user_title_'.$chat_info['id'].'" class="user-title">'.format_time($chat_info['posted']).'</span>
					'.$unread_msg.'
				</span>
			</li>';
		
	}
?>
								</ul>
							</div>

						</fieldset>
					</div>
				</div>
			</fieldset>
		
		</div>
	
<?php
	if (isset($pan_chat_update_online) )
	{
		foreach ($online_info as $key => $val)
		{
			$update_online_idle = isset($pan_chat_update_online[$key]) ? $pan_chat_update_online[$key]['idle'] : 1;
			if ($update_online_idle == 1 && $val['idle'] == 0 && $forum_user['id'] != $key)
			{
				echo '<div id="new_online" data-item="'.$key.'"><audio autoplay>
							<source src="'.$forum_url['pan_private_chat_url'].'/sound/online.wav" type="audio/wav">
							<source src="'.$forum_url['pan_private_chat_url'].'/sound/online.ogg" type="audio/ogg">
							<source src="'.$forum_url['pan_private_chat_url'].'/sound/online.mp3" type="audio/mpeg">
						</audio></div>';
			}
		}
	}

	if (isset($pan_chat_new_msg) && isset($unread_messages[$forum_user['id']]) )
	{
		foreach ($unread_messages[$forum_user['id']] as $key => $val)
		{
			$new_msg_old = isset($pan_chat_new_msg[$forum_user['id']][$key]) ? $pan_chat_new_msg[$forum_user['id']][$key] : 0;
			
			if ($val > $new_msg_old)
			{
				echo '<audio autoplay>
						<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.wav" type="audio/wav">
						<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.ogg" type="audio/ogg">
						<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.mp3" type="audio/mpeg">
					</audio>';
			}
		}
	}

	if (time() > ($pan_chat_update_online['last_update']+15) )
		pan_chat_gen_cache_update_online($online_info);
	
	pan_chat_gen_cache_new_msg($unread_messages);
}
else if ($action == 'settings')
{

	if (isset($_POST['sent']) && $_POST['sent'] == 1)
	{
		if ($forum_user['g_id'] == FORUM_ADMIN)
		{
			$form = array_map('trim', $_POST['form']);
			
			foreach ($form as $key => $input)
			{
				// Only update option values that have changed
				if (array_key_exists('o_'.$key, $forum_config) && $forum_config['o_'.$key] != $input)
				{
					if ($input != '' || is_int($input))
						$value = '\''.$forum_db->escape($input).'\'';
					else
						$value = 'NULL';

					$query = array(
						'UPDATE'	=> 'config',
						'SET'		=> 'conf_value='.$value,
						'WHERE'		=> 'conf_name=\'o_'.$forum_db->escape($key).'\''
					);
					$forum_db->query_build($query) or error(__FILE__, __LINE__);
				}
			}
		
			// Regenerate the config cache
			if (!defined('FORUM_CACHE_FUNCTIONS_LOADED') )
			{
				require FORUM_ROOT.'include/cache.php';
				generate_config_cache();
			}

			// If changed sef - remove quick-jump cache
			if (!empty($forum_config['o_sef']) && !empty($form['sef']) )
			{
				if ($forum_config['o_sef'] != $form['sef'])
				{
					clean_quickjump_cache();
				}
			}
		}

		$user_form = array_map('trim', $_POST['user']);
		$user_config = serialize($user_form);
		
		$query = array(
			'UPDATE'	=> 'users',
			'SET'		=> 'pan_chat_data=\''.$forum_db->escape($user_config).'\'',
			'WHERE'		=> 'id='.$forum_user['id']
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		

		echo '<audio autoplay>
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/save.wav" type="audio/wav">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/save.ogg" type="audio/ogg">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/save.mp3" type="audio/mpeg">
			</audio>';

	}

	$forum_user['pan_chat_data'] = unserialize($forum_user['pan_chat_data']);

?>
		<form id="form_settings" class="frm-form" method="post" accept-charset="utf-8" action="javascript:void(null);">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_private_chat_body'])) ?>" />
				<input type="hidden" name="action" value="settings" />
				<input type="hidden" name="sent" value="1" />
			</div>
			
<?php
if ($forum_user['g_id'] == FORUM_ADMIN) {
?>
			<div class="content-head">
				<h2 class="hn"><span><?php echo $lang_pan_private_chat['config_admin'] ?></span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_private_chat['max_num_msg'] ?></span><small><?php echo $lang_pan_private_chat['max_num_msg_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" name="form[pan_private_chat_max_num_msg]" size="10" maxlength="3" value="<?php echo (isset($_POST['form']['pan_private_chat_max_num_msg']) ? $_POST['form']['pan_private_chat_max_num_msg'] : $forum_config['o_pan_private_chat_max_num_msg']) ?>" /></span>
				</div>
			</div>
			
			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_private_chat['max_lenght_msg'] ?></span><small><?php echo $lang_pan_private_chat['max_lenght_msg_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" name="form[pan_private_chat_max_lenght_msg]" size="10" maxlength="6" value="<?php echo (isset($_POST['form']['pan_private_chat_max_lenght_msg']) ? $_POST['form']['pan_private_chat_max_lenght_msg'] : $forum_config['o_pan_private_chat_max_lenght_msg']) ?>" /></span>
				</div>
			</div>
			
			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span><?php echo $lang_pan_private_chat['active_contacts'] ?></span><small><?php echo $lang_pan_private_chat['active_contacts_i'] ?></small></label><br />
					<span class="fld-input"><input type="number" name="form[pan_private_chat_active_contacts]" size="10" maxlength="4" value="<?php echo (isset($_POST['form']['pan_private_chat_active_contacts']) ? $_POST['form']['pan_private_chat_active_contacts'] : $forum_config['o_pan_private_chat_active_contacts']) ?>" /></span>
				</div>
			</div>
			
<?php
}
	$form_set = array();
	if (isset($_POST['user']) ) {
		foreach ($_POST['user'] as $key => $value) {
			$form_set[$key] = $value;
		}
	} else if (is_array($forum_user['pan_chat_data']) ) {
		foreach ($forum_user['pan_chat_data'] as $key => $value) {
			$form_set[$key] = $value;
		}
	} else {
		$form_set['sound_notify'] = $form_set['email_notify'] = $form_set['frame_notify'] = 1;
	}
?>
			<div class="content-head">
				<h2 class="hn"><span><?php echo $lang_pan_private_chat['config_user'] ?></span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box checkbox">
					<input type="hidden" name="user[sound_notify]" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld" name="user[sound_notify]" value="1" <?php if($form_set['sound_notify'] == '1') echo 'checked="checked"' ?> /></span>
					<label for="fld "><span><?php echo $lang_pan_private_chat['sound_notify'] ?></span><?php echo $lang_pan_private_chat['sound_notify_i'] ?></label>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box checkbox">
					<input type="hidden" name="user[email_notify]" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld" name="user[email_notify]" value="1" <?php if($form_set['email_notify'] == '1') echo 'checked="checked"' ?> /></span>
					<label for="fld "><span><?php echo $lang_pan_private_chat['email_notify'] ?></span><?php echo $lang_pan_private_chat['email_notify_i'] ?></label>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box checkbox">
					<input type="hidden" name="user[frame_notify]" value="0" />
						<span class="fld-input"><input type="checkbox" id="fld" name="user[frame_notify]" value="1" <?php if($form_set['frame_notify'] == '1') echo 'checked="checked"' ?> /></span>
					<label for="fld "><span><?php echo $lang_pan_private_chat['frame_notify'] ?></span><?php echo $lang_pan_private_chat['frame_notify_i'] ?></label>
				</div>
			</div>

			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" value="<?php echo $lang_pan_private_chat['button_save'] ?>" OnClick="chatSaveConfig();"></span>
			</div>
			
		</form>
<?php
}


//print_r($_FILES);
//print_r($_POST);

// If there were any errors, show them
if (!empty($errors))
{
	$forum_page['errors'] = array();
	foreach ($errors as $cur_error)
		$forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
?>
		<div class="ct-box error-box">
			<h2 class="warn hn"><?php echo $lang_post['Post errors'] ?></h2>
			<ul class="error-list">
				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
			</ul>
		</div>
<?php
}

//json_encode($errors);
//print_r(json_encode($_POST) );
//print_r($_POST);

// End the transaction
$forum_db->end_transaction();

// Close the db connection (and free up any result data)
$forum_db->close();
