<?php

if (!defined('FORUM_ROOT') )
	define('FORUM_ROOT', '../../../');

require FORUM_ROOT.'include/common.php';
require $forum_url['pan_private_chat_path'].'/inc/functions.php';
require $forum_url['pan_private_chat_path'].'/inc/chat_parser.php';

if ($forum_user['is_guest'])
	message($lang_common['Bad request']);

$action = isset($_POST['action']) ? $_POST['action'] : null;
$errors = $forum_page = $return_data = array();

if (file_exists(FORUM_ROOT.'extensions/pan_private_chat/lang/'.$forum_user['language'].'/pan_private_chat.php') )
	require FORUM_ROOT.'extensions/pan_private_chat/lang/'.$forum_user['language'].'/pan_private_chat.php';
else
	require FORUM_ROOT.'extensions/pan_private_chat/lang/English/pan_private_chat.php';

$online_info = array();
$query = array(
	'SELECT'	=> 'o.user_id, o.logged, o.idle',
	'FROM'		=> 'online AS o',
	'WHERE'		=> 'o.user_id > 1'
);
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
while ($fetch_online = $forum_db->fetch_assoc($result))
	$online_info[$fetch_online['user_id']] = $fetch_online;//['user_id']

if ($action == 'list_users')
{
	$unread_messages = pan_private_chat_get_unread_msg();
	
	if (file_exists($forum_url['pan_private_chat_path'].'/cache/update_online.php') )
		require $forum_url['pan_private_chat_path'].'/cache/update_online.php';
	else
		pan_chat_gen_cache_update_online($online_info);
	
	if (file_exists($forum_url['pan_private_chat_path'].'/cache/new_msg.php') )
		require $forum_url['pan_private_chat_path'].'/cache/new_msg.php';
	else
		pan_chat_gen_cache_new_msg($unread_messages);
	
	$list_chats = array();
	$query = array(
		'SELECT'	=> 'ch.id AS chid, ch.sender, ch.sender_id, ch.receiver, ch.receiver_id, ch.message, ch.posted, ch.status, u.id, u.username, u.avatar',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'users AS u',
				'ON'			=> '(u.id=ch.sender_id) OR (u.id=ch.receiver_id)'
			)
		),
		'FROM'		=> 'pan_private_chat AS ch',
		'WHERE'		=> 'ch.sender_id='.$forum_user['id'].' OR ch.receiver_id='.$forum_user['id'],
		'ORDER BY'	=> 'ch.posted DESC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	while ($chat_info = $forum_db->fetch_assoc($result))
	{
		if ($chat_info['id'] != $forum_user['id'])
		{
			if (!isset($list_chats[$chat_info['id']]) )
				$list_chats[$chat_info['id']] = $chat_info;
			else if ($chat_info['posted'] > $list_chats[$chat_info['id']]['posted'])
				$list_chats[$chat_info['id']] = $chat_info;
		}
	}
	
	$list_chats = pan_chat_sort_online($list_chats, $online_info);

	if ($forum_db->num_rows($result) < 1)
		echo '<span class="dialog-empty">'.$lang_pan_private_chat['not_dialogs'].'</span>';

?>

	<div id="list_users" class="user-list">
		<ul>
<?php
	foreach ($list_chats as $chid => $chat_info)
	{
		if (isset($unread_messages[$forum_user['id']][$chat_info['sender_id']]) )
			$unread_msg = '<span class="unread-msg">'.$unread_messages[$forum_user['id']][$chat_info['sender_id']].'</span>';
		else
			$unread_msg = '';
		
		if (isset($online_info[$chid]) )
		{
			if ($online_info[$chid]['idle'] == '0')
				$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/online.gif" />';
			else if ($online_info[$chid]['idle'] == '1')
				$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/departed.png" />';
		} else {
			$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/offline.png" />';
		}
		
		echo '<li>
				<div class="user-info">
					'.$status.'
					<span id="user_title_'.$chat_info['id'].'"><a href="javascript://" onclick="mChatDialog('.$chat_info['id'].');">'.$chat_info['username'].'</a><span>
					'.$unread_msg.'
				</div>
			</li>';
	}
?>
		</ul>
	</div>

<?php

	if (isset($pan_chat_update_online) )
	{
		foreach ($online_info as $key => $val)
		{
			$update_online_idle = isset($pan_chat_update_online[$key]) ? $pan_chat_update_online[$key]['idle'] : 1;
			if ($update_online_idle == 1 && $val['idle'] == 0 && $forum_user['id'] != $key)
			{
				echo '<div id="new_online" data-item="'.$key.'"><audio autoplay>
							<source src="'.$forum_url['pan_private_chat_url'].'/sound/online.wav" type="audio/wav">
							<source src="'.$forum_url['pan_private_chat_url'].'/sound/online.ogg" type="audio/ogg">
							<source src="'.$forum_url['pan_private_chat_url'].'/sound/online.mp3" type="audio/mpeg">
						</audio></div>';
			}
		}
	}
	
	if (isset($pan_chat_new_msg) && isset($unread_messages[$forum_user['id']]) )
	{
		foreach ($unread_messages[$forum_user['id']] as $key => $val)
		{
			$new_msg_old = isset($pan_chat_new_msg[$forum_user['id']][$key]) ? $pan_chat_new_msg[$forum_user['id']][$key] : 0;
			
			if ($val > $new_msg_old)
			{
				echo '<audio autoplay>
						<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.wav" type="audio/wav">
						<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.ogg" type="audio/ogg">
						<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.mp3" type="audio/mpeg">
					</audio>';
			}
		}
	}

	if (time() > ($pan_chat_update_online['last_update']+15) )
		pan_chat_gen_cache_update_online($online_info);
	
	pan_chat_gen_cache_new_msg($unread_messages);
}
else if ($action == 'dialog')
{
	$uid = isset($_POST['uid']) ? intval($_POST['uid']) : 0;
	
	if ($uid > 1)
	{
		$query = array(
			'SELECT'	=> 'u.username',
			'FROM'		=> 'users AS u',
			'WHERE'		=> 'u.id='.$uid,
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$user_info = $forum_db->fetch_assoc($result);
		$receiver = $user_info['username'];
		
		$query = array(
			'SELECT'	=> 'ch.id, ch.sender, ch.sender_id, ch.receiver, ch.receiver_id, ch.message, ch.posted, ch.status',
			'FROM'		=> 'pan_private_chat AS ch',
			'WHERE'		=> '(ch.receiver_id='.$uid.' AND ch.sender_id='.$forum_user['id'].') OR (ch.receiver_id='.$forum_user['id'].' AND ch.sender_id='.$uid.')', 
			'ORDER BY'	=> 'ch.posted ASC'
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
		if (isset($online_info[$uid]) )
		{
			if ($online_info[$uid]['idle'] == '0')
				$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/online.gif" />';
			else if ($online_info[$uid]['idle'] == '1')
				$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/departed.png" />';
		} else {
			$status = '<img src="'.$forum_url['pan_private_chat_url'].'/img/status/offline.png" />';
		}
?>

		<div class="chat-content-head">
			<?php echo $status ?>
			
			<span><strong><a href="<?php echo forum_link($forum_url['user'], $uid) ?>" target="_blank" title="<?php echo $lang_pan_private_chat['open_new_window'] ?>"><?php echo $receiver ?></a></strong></span>
			
			<span style="float:right;"><strong><a href="javascript://" onclick="mChatListUsers();">Dialogs</a></strong></span>
		</div>

		<div class="mini-chat-dialog">
			
			<div id="chat_list_msg"></div>
			
			<form id="form_sent" class="frm-form" method="post" accept-charset="utf-8" action="javascript:void(null);">

				<div class="hidden">
					<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_private_chat_body'])) ?>" />
					<input type="hidden" name="action" value="add_msg" />
					<input type="hidden" name="uid" value="<?php echo $uid ?>" />
				</div>
				
				<div id="chat_smilies" style="display:none">
					<?php pan_chat_smiles($forum_url['pan_private_chat_url'].'/img/smiles/'); ?>
				</div>
				
				<div class="chat-textarea">
					<span class="chat-fld-input">
							<textarea id="textarea_msg" name="message" rows="2" cols="auto" maxlength="<?php echo $max_lenght_msg ?>" placeholder="Write your message" ></textarea>
					</span>
				</div>
				
				<div id="mini_chat_buttons">
					
					<img src="<?php echo $base_url ?>/extensions/pan_private_chat/img/smiles/ab.gif" id="chat_bbcode_button_smiles" class="image chat-btn-img" onclick="chatShowHide('chat_smilies');" title="<?php echo $lang_pan_private_chat['button_title_smiles'] ?>">
					
					<img src="<?php echo $base_url ?>/extensions/pan_private_chat/img/button/send_msg.jpg" id="chat_bbcode_button_send" class="image chat-btn-img" OnClick="mChatSendMessage();" title="Send message">
					
				</div>
			
			</form>
			
		</div>
<?php
		//Update Status
		$query = array(
			'UPDATE'	=> 'pan_private_chat',
			'SET'		=> 'status=\'read\'',
			'WHERE'		=> 'sender_id='.$uid.' AND receiver_id='.$forum_user['id']
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

	}

}
else if ($action == 'list_msg')
{
	$uid = isset($_POST['uid']) ? intval($_POST['uid']) : 0;

	if ($uid > 1)
	{
		$query = array(
			'SELECT'	=> 'u.username',
			'FROM'		=> 'users AS u',
			'WHERE'		=> 'u.id='.$uid,
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$user_info = $forum_db->fetch_assoc($result);
		$receiver = $user_info['username'];
		
		$query = array(
			'SELECT'	=> 'ch.id, ch.sender, ch.sender_id, ch.receiver, ch.receiver_id, ch.message, ch.posted, ch.status',
			'FROM'		=> 'pan_private_chat AS ch',
			'WHERE'		=> '(ch.receiver_id='.$uid.' AND ch.sender_id='.$forum_user['id'].') OR (ch.receiver_id='.$forum_user['id'].' AND ch.sender_id='.$uid.')', 
			'ORDER BY'	=> 'ch.posted ASC'
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
?>

	<div id="list_msg" class="list-msg">
		<ul>
<?php
		if ($forum_db->num_rows($result) < 1)
			echo '<li><span class="dialog-empty">'.$lang_pan_private_chat['no_msg'].' <strong>'.$receiver.'</strong></span></li>';
		
		$sound_new_msg = false;
		while ($chat_info = $forum_db->fetch_assoc($result) )
		{
			$chat_message = parse_message($chat_info['message'], 0);
			
			if ($chat_info['sender_id'] == $forum_user['id'])
			{
				
				$sender_status = $chat_info['status'] == 'read' ? '<span class="sender-status-read">'.$lang_pan_private_chat['status_read'].'</span>' : '<span class="sender-status-sent">'.$lang_pan_private_chat['status_sent'].'</span>';
				
				echo '<li>
						<div class="sender">
							<div class="sender-info">
								<span class="sender-name">'. $forum_user['username'].': '.format_time($chat_info['posted']).'</span>
								<div class="sender-msg">'.$chat_message.'</div>
							</div>
						</div>
					</li>';
			}
			else if ($chat_info['sender_id'] == $uid)
			{
				echo '<li>
						<div class="receiver">
							<div class="receiver-info">
								<span class="receiver-name">'. $receiver.': '.format_time($chat_info['posted']).'</span>
								<div class="receiver-msg">'.$chat_message.'</div>
							</div>
						</div>
					</li>';
					
			if ($chat_info['status'] == 'sent')
				$sound_new_msg = true;
			}
		
		}
?>
		</ul>
	</div>
<?php
		if ($sound_new_msg === true)
		{
			echo '<audio autoplay>
					<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.wav" type="audio/wav">
					<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.ogg" type="audio/ogg">
					<source src="'.$forum_url['pan_private_chat_url'].'/sound/inbox_msg.mp3" type="audio/mpeg">
				</audio>';
		}
		
		
		//Update Status
		$query = array(
			'UPDATE'	=> 'pan_private_chat',
			'SET'		=> 'status=\'read\'',
			'WHERE'		=> 'sender_id='.$uid.' AND receiver_id='.$forum_user['id']
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		
	}
}
else if ($action == 'add_msg')
{
	// Load the post.php language file
	require FORUM_ROOT.'lang/'.$forum_user['language'].'/post.php';

	$uid = isset($_POST['uid']) ? intval($_POST['uid']) : 0;
	if ($uid > 1) {
			$query = array(
			'SELECT'	=> 'u.username',
			'FROM'		=> 'users AS u',
			'WHERE'		=> 'u.id='.$uid,
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$user_info = $forum_db->fetch_assoc($result);
		$receiver = $user_info['username'];
	}

	$message = isset($_POST['message']) ? forum_linebreaks(forum_trim($_POST['message'])) : '';

	$max_lenght_msg = ($forum_config['o_pan_private_chat_max_lenght_msg'] > 0) ? $forum_config['o_pan_private_chat_max_lenght_msg'] : '10000';

	if (iconv_strlen($message, 'UTF-8') > $forum_config['o_pan_private_chat_max_lenght_msg'])
		$errors[] = sprintf($lang_post['Too long message'], forum_number_format( iconv_strlen($message, 'UTF-8') ), forum_number_format($forum_config['o_pan_private_chat_max_lenght_msg']));

	if (isset($_FILES['file']['tmp_name']) )
	{
		$ext_types = array('.jpg', '.jpeg', '.png', '.gif');
		$file_tmp_name = $_FILES['file']['tmp_name'];
		$file_name = $_FILES['file']['name'];
		$file_size = $_FILES['file']['size'];
		$file_ext = strtolower(strrchr($file_name,'.') );
		$file_name = sha1($file_tmp_name.time() );
		
		$path_to_file = $forum_url['pan_private_chat_path'] .'/cache/images/'. $file_name.$file_ext;
		$url_to_file = $forum_url['pan_private_chat_url'] .'/cache/images/'. $file_name.$file_ext;
		
		if (in_array($file_ext, $ext_types) && $file_size < 500000)
		{
			if (move_uploaded_file($file_tmp_name, $path_to_file) )
			{
				$message = '[img]'.$url_to_file.'[/img]';
			}
		} else {
			$errors[] = $lang_pan_private_chat['error_img_size'];
		}
	}

	$message = preparse_bbcode($message, $errors);

	if ($message == '')
		$errors[] = $lang_post['No message'];

	if (empty($errors) && $uid > 0 && $message != '')
	{
		$query = array(
			'INSERT'	=> 'sender, sender_id, receiver, receiver_id, message, posted, status',
			'INTO'		=> 'pan_private_chat',
			'VALUES'	=> '\''.$forum_db->escape($forum_user['username']).'\', \''.$forum_db->escape($forum_user['id']).'\', \''.$forum_db->escape($receiver).'\', \''.$forum_db->escape($uid).'\', \''.$forum_db->escape($message).'\', '.time().', \'sent\''
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
		$new_id_msg = $forum_db->insert_id();
		
		//Send message to Email once
		$query = array(
			'SELECT'	=> 'COUNT(id)',
			'FROM'		=> 'pan_private_chat',
			'WHERE'		=> 'receiver_id='.$uid.' AND sender_id='.$forum_user['id'].' AND status=\'sent\'',
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$num_new_msg = $forum_db->result($result);

		//Send message to email
		if ($num_new_msg < 2)
			pan_private_chat_email_new_msg($uid);
		
	}

	if ($uid > 0 && !empty($receiver))
	{

		
		$query = array(
			'SELECT'	=> 'ch.id, ch.sender, ch.sender_id, ch.receiver, ch.receiver_id, ch.message, ch.posted, ch.status',
			'FROM'		=> 'pan_private_chat AS ch',
			'WHERE'		=> '(ch.receiver_id='.$uid.' AND ch.sender_id='.$forum_user['id'].') OR (ch.receiver_id='.$forum_user['id'].' AND ch.sender_id='.$uid.')',
			'ORDER BY'	=> 'ch.posted ASC'
		);
		
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

?>
	<div id="list_msg" class="list-msg">
		<ul>
<?php
		if ($forum_db->num_rows($result) < 1)
			echo '<li><span class="dialog-empty">'.$lang_pan_private_chat['no_msg'].' <strong>'.$receiver.'</strong></span></li>';
		
		$sound_new_msg = false;
		while ($chat_info = $forum_db->fetch_assoc($result) )
		{
			$chat_message = parse_message($chat_info['message'], 0);
			
			if ($chat_info['sender_id'] == $forum_user['id'])
			{
				
				$sender_status = $chat_info['status'] == 'read' ? '<span class="sender-status-read">'.$lang_pan_private_chat['status_read'].'</span>' : '<span class="sender-status-sent">'.$lang_pan_private_chat['status_sent'].'</span>';
				
				echo '<li>
						<div class="sender">
							<div class="sender-info">
								<span class="sender-name">'. $forum_user['username'].': '.format_time($chat_info['posted']).'</span>
								<div class="sender-msg">'.$chat_message.'</div>
							</div>
						</div>
					</li>';
			}
			else if ($chat_info['sender_id'] == $uid)
			{
				echo '<li>
						<div class="receiver">
							<div class="receiver-info">
								<span class="receiver-name">'. $receiver.': '.format_time($chat_info['posted']).'</span>
								<div class="receiver-msg">'.$chat_message.'</div>
							</div>
						</div>
					</li>';
					
			if ($chat_info['status'] == 'sent')
				$sound_new_msg = true;
			}
		
		}
?>
		</ul>
	</div>
	
<?php

		if (isset($chat_min_id) && ($count_max_msg > $forum_config['o_pan_private_chat_max_num_msg']) )
		{
			$query = array(
				'DELETE'	=> 'pan_private_chat',
				'WHERE'		=> 'id='.$chat_min_id,
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
		}
		
		if (isset($new_id_msg) )
		{
			echo '<audio autoplay>
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/message.wav" type="audio/wav">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/message.ogg" type="audio/ogg">
				<source src="'.$forum_url['pan_private_chat_url'].'/sound/message.mp3" type="audio/mpeg">
			</audio>';
		}
		
	}

	pan_chat_get_uploaded_imgs($forum_url['pan_private_chat_path'] .'/cache/images', $all_files);
	
	if (!empty($all_files) )
		pan_chat_clear_images($all_files);

}

?>

<?php
//print_r($_FILES);
//print_r($chat_info);

// If there were any errors, show them


//json_encode($errors);
//print_r(json_encode($_POST) );
//print_r($_POST);

// End the transaction
$forum_db->end_transaction();

// Close the db connection (and free up any result data)
$forum_db->close();
